Fix testing canonicalize on cygwin.
authorEric Blake <ebb9@byu.net>
Fri, 6 Jul 2007 14:22:21 +0000 (14:22 +0000)
committerEric Blake <ebb9@byu.net>
Fri, 6 Jul 2007 14:22:21 +0000 (14:22 +0000)
* modules/canonicalize-lgpl-tests (test_canonicalize_lgpl_LDADD):
Revert patch from 2007-06-19.
* tests/test-canonicalize-lgpl.c (main): Instead, skip test when
canonicalize module is also in use.
* tests/test-canonicalize.c: New file.
* tests/test-canonicalize.sh: Likewise.
* modules/canonicalize-tests: Likewise.

ChangeLog
modules/canonicalize-lgpl-tests
modules/canonicalize-tests [new file with mode: 0644]
tests/test-canonicalize-lgpl.c
tests/test-canonicalize.c [new file with mode: 0644]
tests/test-canonicalize.sh [new file with mode: 0644]

index 4ea7df6..93e5564 100644 (file)
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,14 @@
+2007-07-06  Eric Blake  <ebb9@byu.net>
+
+       Fix testing canonicalize on cygwin.
+       * modules/canonicalize-lgpl-tests (test_canonicalize_lgpl_LDADD):
+       Revert patch from 2007-06-19.
+       * tests/test-canonicalize-lgpl.c (main): Instead, skip test when
+       canonicalize module is also in use.
+       * tests/test-canonicalize.c: New file.
+       * tests/test-canonicalize.sh: Likewise.
+       * modules/canonicalize-tests: Likewise.
+
 2007-07-06  Jim Meyering  <jim@meyering.net>
 
        * lib/getugroups.c (getugroups): Detect getgrent failure.
index 3fbc43d..29391e5 100644 (file)
@@ -11,4 +11,4 @@ TESTS += test-canonicalize-lgpl.sh
 TESTS_ENVIRONMENT += EXEEXT='@EXEEXT@'
 check_PROGRAMS += test-canonicalize-lgpl
 EXTRA_DIST += test-canonicalize-lgpl.sh
-test_canonicalize_lgpl_LDADD = $(LDADD) @LIBINTL@
+test_canonicalize_lgpl_LDADD = $(LDADD)
diff --git a/modules/canonicalize-tests b/modules/canonicalize-tests
new file mode 100644 (file)
index 0000000..bbdfbd1
--- /dev/null
@@ -0,0 +1,14 @@
+Files:
+tests/test-canonicalize.sh
+tests/test-canonicalize.c
+
+Depends-on:
+
+configure.ac:
+
+Makefile.am:
+TESTS += test-canonicalize.sh
+TESTS_ENVIRONMENT += EXEEXT='@EXEEXT@'
+check_PROGRAMS += test-canonicalize
+EXTRA_DIST += test-canonicalize.sh
+test_canonicalize_LDADD = $(LDADD) @LIBINTL@
index 7142201..db618ba 100644 (file)
 int
 main ()
 {
+#ifdef GNULIB_CANONICALIZE
+  /* No need to test canonicalize-lgpl module if canonicalize is also
+     in use.  */
+  return 0;
+#endif
+
   /* Check that the symbolic link to a file can be resolved.  */
   {
     char *result1 = canonicalize_file_name ("t-can-lgpl.tmp/huk");
diff --git a/tests/test-canonicalize.c b/tests/test-canonicalize.c
new file mode 100644 (file)
index 0000000..8003743
--- /dev/null
@@ -0,0 +1,131 @@
+/* Test of execution of file name canonicalization.
+   Copyright (C) 2007 Free Software Foundation, Inc.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */
+
+/* Written by Bruno Haible <bruno@clisp.org>, 2007.  */
+
+#include <config.h>
+
+#include "canonicalize.h"
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+#define ASSERT(expr) \
+  do                                                                        \
+    {                                                                       \
+      if (!(expr))                                                          \
+        {                                                                   \
+          fprintf (stderr, "%s:%d: assertion failed\n", __FILE__, __LINE__); \
+          abort ();                                                         \
+        }                                                                   \
+    }                                                                       \
+  while (0)
+
+const char *program_name = "test-canonicalize";
+
+int
+main ()
+{
+  /* Check that the symbolic link to a file can be resolved.  */
+  {
+    char *result1 = canonicalize_file_name ("t-can.tmp/huk");
+    char *result2 = canonicalize_file_name ("t-can.tmp/tra");
+    char *result3 = canonicalize_filename_mode ("t-can.tmp/huk", CAN_EXISTING);
+    ASSERT (result1 != NULL);
+    ASSERT (result2 != NULL);
+    ASSERT (result3 != NULL);
+    ASSERT (strcmp (result1, result2) == 0);
+    ASSERT (strcmp (result2, result3) == 0);
+    ASSERT (strcmp (result1 + strlen (result1) - 14, "/t-can.tmp/tra") == 0);
+    free (result1);
+    free (result2);
+    free (result3);
+  }
+
+  /* Check that the symbolic link to a directory can be resolved.  */
+  {
+    char *result1 = canonicalize_file_name ("t-can.tmp/plo");
+    char *result2 = canonicalize_file_name ("t-can.tmp/bef");
+    char *result3 = canonicalize_file_name ("t-can.tmp/lum");
+    char *result4 = canonicalize_filename_mode ("t-can.tmp/plo", CAN_EXISTING);
+    ASSERT (result1 != NULL);
+    ASSERT (result2 != NULL);
+    ASSERT (result3 != NULL);
+    ASSERT (result4 != NULL);
+    ASSERT (strcmp (result1, result2) == 0);
+    ASSERT (strcmp (result2, result3) == 0);
+    ASSERT (strcmp (result3, result4) == 0);
+    ASSERT (strcmp (result1 + strlen (result1) - 14, "/t-can.tmp/lum") == 0);
+    free (result1);
+    free (result2);
+    free (result3);
+    free (result4);
+  }
+
+  /* Check that a symbolic link to a nonexistent file yields NULL.  */
+  {
+    char *result1 = canonicalize_file_name ("t-can.tmp/ouk");
+    char *result2 = canonicalize_filename_mode ("t-can.tmp/ouk", CAN_EXISTING);
+    ASSERT (result1 == NULL);
+    ASSERT (result2 == NULL);
+  }
+
+  /* Check that a loop of symbolic links is detected.  */
+  {
+    char *result1 = canonicalize_file_name ("ise");
+    char *result2 = canonicalize_filename_mode ("ise", CAN_EXISTING);
+    ASSERT (result1 == NULL);
+    ASSERT (result2 == NULL);
+  }
+
+  /* Check that alternate modes can resolve missing basenames.  */
+  {
+    char *result1 = canonicalize_filename_mode ("t-can.tmp/zzz", CAN_ALL_BUT_LAST);
+    char *result2 = canonicalize_filename_mode ("t-can.tmp/zzz", CAN_MISSING);
+    ASSERT (result1 != NULL);
+    ASSERT (result2 != NULL);
+    ASSERT (strcmp (result1, result2) == 0);
+    ASSERT (strcmp (result1 + strlen (result1) - 14, "/t-can.tmp/zzz") == 0);
+    free (result1);
+    free (result2);
+  }
+
+  /* Check that alternate modes can resolve broken symlink basenames.  */
+  {
+    char *result1 = canonicalize_filename_mode ("t-can.tmp/ouk", CAN_ALL_BUT_LAST);
+    char *result2 = canonicalize_filename_mode ("t-can.tmp/ouk", CAN_MISSING);
+    ASSERT (result1 != NULL);
+    ASSERT (result2 != NULL);
+    ASSERT (strcmp (result1, result2) == 0);
+    ASSERT (strcmp (result1 + strlen (result1) - 14, "/t-can.tmp/wum") == 0);
+    free (result1);
+    free (result2);
+  }
+
+  /* Check that alternate modes can handle missing dirnames.  */
+  {
+    char *result1 = canonicalize_filename_mode ("t-can.zzz/zzz", CAN_ALL_BUT_LAST);
+    char *result2 = canonicalize_filename_mode ("t-can.zzz/zzz", CAN_MISSING);
+    ASSERT (result1 == NULL);
+    ASSERT (result2 != NULL);
+    ASSERT (strcmp (result2 + strlen (result2) - 14, "/t-can.zzz/zzz") == 0);
+    free (result2);
+  }
+
+  return 0;
+}
diff --git a/tests/test-canonicalize.sh b/tests/test-canonicalize.sh
new file mode 100644 (file)
index 0000000..2992e5f
--- /dev/null
@@ -0,0 +1,28 @@
+#!/bin/sh
+
+tmpfiles=""
+trap 'rm -fr $tmpfiles' 1 2 3 15
+
+tmpfiles="$tmpfiles t-can.tmp ise"
+mkdir t-can.tmp
+ln -s t-can.tmp/ket ise \
+  || { echo "Skipping test: symbolic links not supported on this filesystem"
+       rm -fr $tmpfiles
+       exit 77
+     }
+(cd t-can.tmp \
+ && ln -s bef plo \
+ && ln -s tra huk \
+ && ln -s lum bef \
+ && ln -s wum ouk \
+ && ln -s ../ise ket \
+ && echo > tra \
+ && mkdir lum
+) || exit 1
+
+./test-canonicalize${EXEEXT}
+result=$?
+
+rm -fr $tmpfiles
+
+exit $result